&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------
  File: xmltest.w
  Description:   Post XML via HTTP to a specified URL and display the result
  Input Parameters:
      <none>
  Output Parameters:
      <none>
  Author: S.E. Southwell - BravePoint, Inc. - ses@bravepointdallas.com
        (Thanks to PSC Kbase 22003 - 30/Apr/2002)
  Created: 8/5/02
  Modified:
            Thanks to Wim van der Ham for UI improvements.
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/


/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */


CREATE WIDGET-POOL.


/* ***************************  Definitions  ************************** */


/* Parameters Definitions ---                                           */


/* Local Variable Definitions ---                                       */



DEFINE VARIABLE vcWebHost   AS CHARACTER NO-UNDO.           
DEFINE VARIABLE vcWebPort   AS CHARACTER NO-UNDO.
DEFINE VARIABLE vcWSAgent   AS CHARACTER NO-UNDO.     
DEFINE VARIABLE vcWebResp   AS CHARACTER NO-UNDO.     
DEFINE VARIABLE vhWebSocket AS HANDLE    NO-UNDO.
DEFINE VARIABLE vpWebResp   AS MEMPTR    NO-UNDO.
DEFINE VARIABLE viReadCount AS INTEGER   NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS eRequest fiURL btnPost fiQueryString ~
eResponse 
&Scoped-Define DISPLAYED-OBJECTS eRequest fiURL fiQueryString eResponse ~
fiBytes fiEtime 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD MemptrAppend C-Win 
FUNCTION MemptrAppend RETURNS MEMPTR
  ( INPUT myFirst AS MEMPTR,
    INPUT mySecond AS MEMPTR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD MemptrTrim C-Win 
FUNCTION MemptrTrim RETURNS MEMPTR
  ( INPUT myMemPtr AS MEMPTR )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD UrlParse C-Win 
FUNCTION UrlParse RETURNS LOGICAL(
 INPUT myURL AS CHAR,
 OUTPUT myHost AS CHAR,
 OUTPUT myPort AS CHAR,
 OUTPUT myPath AS CHAR  
)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnPost 
     LABEL "Post" 
     SIZE 7 BY 1.14.

DEFINE BUTTON btnStop 
     LABEL "Stop" 
     SIZE 7.4 BY 1.14.

DEFINE VARIABLE eRequest AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 106 BY 6.67 DROP-TARGET NO-UNDO.

DEFINE VARIABLE eResponse AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     SIZE 106 BY 12.86 NO-UNDO.

DEFINE VARIABLE fiBytes AS INTEGER FORMAT ">,>>>,>>9":U INITIAL 0 
     LABEL "Bytes" 
      VIEW-AS TEXT 
     SIZE 14 BY .62 NO-UNDO.

DEFINE VARIABLE fiEtime AS DECIMAL FORMAT "zz9.999":U INITIAL 0 
      VIEW-AS TEXT 
     SIZE 12 BY .62 NO-UNDO.

DEFINE VARIABLE fiQueryString AS CHARACTER FORMAT "X(256)":U 
     LABEL "Query" 
     VIEW-AS FILL-IN 
     SIZE 81 BY 1 TOOLTIP "HTTP Query String (Include ? if used.)" NO-UNDO.

DEFINE VARIABLE fiURL AS CHARACTER FORMAT "X(256)":U 
     LABEL "Address" 
     VIEW-AS FILL-IN 
     SIZE 81.2 BY 1 TOOLTIP "URL of the Web Service" NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     eRequest AT ROW 1.24 COL 1 NO-LABEL
     fiURL AT ROW 8.14 COL 1
     btnPost AT ROW 8.14 COL 92
     btnStop AT ROW 8.14 COL 100
     fiQueryString AT ROW 9.33 COL 8 COLON-ALIGNED
     eResponse AT ROW 10.52 COL 1 NO-LABEL
     fiBytes AT ROW 23.62 COL 7 COLON-ALIGNED
     fiEtime AT ROW 23.62 COL 97 RIGHT-ALIGNED NO-LABEL
     "seconds" VIEW-AS TEXT
          SIZE 9 BY .62 AT ROW 23.62 COL 98
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 106.8 BY 23.33.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "XML HTTP Post Tester"
         HEIGHT             = 23.33
         WIDTH              = 106.8
         MAX-HEIGHT         = 49.24
         MAX-WIDTH          = 280
         VIRTUAL-HEIGHT     = 49.24
         VIRTUAL-WIDTH      = 280
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* SETTINGS FOR BUTTON btnStop IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN fiBytes IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN fiEtime IN FRAME DEFAULT-FRAME
   NO-ENABLE ALIGN-R                                                    */
/* SETTINGS FOR FILL-IN fiURL IN FRAME DEFAULT-FRAME
   ALIGN-L                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* XML HTTP Post Tester */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* XML HTTP Post Tester */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnPost
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnPost C-Win
ON CHOOSE OF btnPost IN FRAME DEFAULT-FRAME /* Post */
DO:
    /* Initialize */
    eResponse:SCREEN-VALUE = "".
    SET-SIZE(vpWebResp) = 0.
    SET-SIZE(vpWebResp) = 1.
    btnPost:SENSITIVE = FALSE.
    btnStop:SENSITIVE = TRUE.
    
    /* Where are they posting to? */
    URLParse(fiURL:SCREEN-VALUE,OUTPUT vcWebHost, OUTPUT vcWebPort, OUTPUT vcWSAgent).  
    
    ETIME(YES).
    
    CREATE SOCKET vhWebSocket.


    vhWebSocket:CONNECT('-H ' + vcWebHost + ' -S ' + vcWebPort ) NO-ERROR.
    IF ERROR-STATUS:ERROR THEN MESSAGE ERROR-STATUS:GET-MESSAGE(1) VIEW-AS ALERT-BOX.
    IF vhWebSocket:CONNECTED() = TRUE THEN DO:
        vhWebSocket:SET-READ-RESPONSE-PROCEDURE('getWebServerResponse').
        RUN PostRequest.
        DO WHILE vhWebSocket:CONNECTED(): /* 30 seconds, max */
            PROCESS EVENTS.
            IF ETIME >= 30000 THEN LEAVE.
            PAUSE 1.
        END.
        
        vhWebSocket:DISCONNECT() NO-ERROR.
        DELETE OBJECT vhWebSocket.
        ASSIGN eResponse:SCREEN-VALUE = get-string(vpWebResp,1,MIN(GET-SIZE(vpWebResp) - 1, 31900)).
        ASSIGN
         vcWebResp = ""
         fiEtime:SCREEN-VALUE = STRING(ETIME / 1000)
         fiBytes:SCREEN-VALUE = STRING(GET-SIZE(vpWebResp))
        .
    END.
    ELSE DO:
       /* error connecting to the Web Server */
       MESSAGE "Unable to connect".
    END.
    
    btnPost:SENSITIVE = TRUE.
    btnStop:SENSITIVE = FALSE.
    RETURN.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnStop
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnStop C-Win
ON CHOOSE OF btnStop IN FRAME DEFAULT-FRAME /* Stop */
DO:
  vhWebSocket:DISCONNECT() NO-ERROR.
  IF ERROR-STATUS:ERROR THEN LEAVE.
  DO WHILE vhWebSocket:CONNECTED():
      PROCESS events.
  END.
  btnStop:SENSITIVE = FALSE.
  btnPost:SENSITIVE = TRUE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME eRequest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL eRequest C-Win
ON DROP-FILE-NOTIFY OF eRequest IN FRAME DEFAULT-FRAME
DO:
   DEFINE VARIABLE cFileName AS CHARACTER  NO-UNDO.
   
   IF SELF:NUM-DROPPED-FILES GT 1 THEN DO:
      MESSAGE "Drop only one file at a time"
      VIEW-AS ALERT-BOX INFO BUTTONS OK.
   END.
   ELSE DO:
      cFileName = SELF:GET-DROPPED-FILE(1).
      SELF:READ-FILE(cFileName).
      SELF:END-FILE-DROP().
   END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */


/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.


/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.


/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY eRequest fiURL fiQueryString eResponse fiBytes fiEtime 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE eRequest fiURL btnPost fiQueryString eResponse 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE GetWebserverResponse C-Win 
PROCEDURE GetWebserverResponse :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    
    DEFINE VARIABLE mResponse   AS MEMPTR.
    DEFINE VARIABLE mTemp       AS MEMPTR.
    DEFINE VARIABLE iSize       AS INTEGER.
    DEFINE VARIABLE iBytesAvail AS INTEGER.
    DEFINE VARIABLE iCopyCount  AS INTEGER.
    DEFINE VARIABLE iLastCount  AS INTEGER.
    DEFINE VARIABLE iBytesRead  AS INTEGER.


    
    REPEAT:
        IF SELF:CONNECTED() = FALSE THEN RETURN.
        ASSIGN iBytesAvail = SELF:GET-BYTES-AVAILABLE().
        IF iBytesAvail = 0 THEN RETURN.
        
        SET-SIZE(mResponse) = iBytesAvail + 1.        
        SET-BYTE-ORDER(mResponse) = BIG-ENDIAN.
        SELF:READ(mResponse,1,iBytesAvail,1) NO-ERROR.
        ASSIGN iBytesRead = SELF:BYTES-READ.
        IF ERROR-STATUS:ERROR THEN LEAVE.
        ASSIGN iSize = GET-SIZE(vpWebResp) - 1.
        
        IF iSize > 0 THEN DO:
            ASSIGN vpWebResp = MemptrAppend(vpWebResp,mResponse).
/*             SET-SIZE(mTemp) = iBytesRead + 1 + iSize.                                                     */
/*             ASSIGN                                                                                        */
/*              iCopyCount = 0                                                                               */
/*              iLastCount = 0                                                                               */
/*             .                                                                                             */
/*             REPEAT:                                                                                       */
/*                 ASSIGN iCopyCount = MIN(iSize - iLastCount,1028).                                         */
/* /*                 MESSAGE "Copying bytes " iLastCount + 1 " - " iLastCount + iCopyCount " of " iSize. */ */
/*                 PUT-BYTES(mTemp,1 + iLastCount) = GET-BYTES(vpWebResp,iLastCount + 1,iCopyCount).         */
/*                 ASSIGN iLastCount = iLastCount + iCopyCount.                                              */
/*                 IF iLastCount = iSize THEN LEAVE.                                                         */
/*             END.                                                                                          */
/*                                                                                                           */
/*             PUT-BYTES(mTemp,iSize + 1) = GET-BYTES(mResponse,1,iBytesRead).                               */
/*             SET-SIZE(vpWebResp) = 0.                                                                      */
/*             SET-SIZE(vpWebResp) = GET-SIZE(mTemp).                                                        */
/*             ASSIGN vpWebResp = mTemp. */
/*             MESSAGE "vpWebResp is " GET-SIZE(vpWebResp) " bytes.". */
        END.
        ELSE DO:
            SET-SIZE(vpWebResp) = iBytesRead + 1.
/*             PUT-BYTES(vpWebResp,1) = GET-BYTES(mResponse,1,iBytesRead). */
            ASSIGN vpWebResp = mResponse.
        END.


        SET-SIZE(mtemp) = 0.
        SET-SIZE(mResponse) = 0.
    END. /*repeat*/


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PostRequest C-Win 
PROCEDURE PostRequest :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/


    DEF VAR viXMLLength AS INTEGER.
    DEF VAR vcRequest AS CHARACTER.
    DEF VAR viRequest AS INTEGER.
    DEF VAR viMsg AS INTEGER.
    DEF VAR mRequest AS MEMPTR.
    DEF VAR lSuccess AS LOGICAL.
        
/* just to be very simple, the XML document is stored in this var */
    DEFINE VARIABLE vcXMLText AS CHARACTER NO-UNDO.
    vcXMLText = eRequest:SCREEN-VALUE IN FRAME {&FRAME-NAME}.         
      
    ASSIGN
        viXMLLength = LENGTH ( vcXMLText )
        vcRequest = 
            'POST ' + vcWSAgent + "?" + fiQueryString:SCREEN-VALUE
          + ' HTTP/1.0~n' 
          + 'Content-Type: text/xml~n'  /* post XML DOC */
          + 'Host: ' + vcWebHost + '~n' 
          + 'Content-Length: ' + STRING(viXMLLength) + '~n' 
          + 'Accept: text/html~n' 
          + '~n'  
        viRequest = LENGTH ( vcRequest )
        viMsg = viRequest + viXMLLength + 1
        .


    SET-SIZE(mRequest)       = 0.
    SET-SIZE(mRequest)       = viMsg.
    SET-BYTE-ORDER(mRequest) = BIG-ENDIAN.


    PUT-STRING(mRequest,1) = vcRequest + vcXMLText.


    vhWebSocket:WRITE(mRequest,1,viMsg) NO-ERROR.


    IF ERROR-STATUS:ERROR THEN DO:
        /* error writing to socket */
    END. 
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION MemptrAppend C-Win 
FUNCTION MemptrAppend RETURNS MEMPTR
  ( INPUT myFirst AS MEMPTR,
    INPUT mySecond AS MEMPTR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/


    DEFINE VARIABLE iCopyCount  AS INTEGER NO-UNDO.
    DEFINE VARIABLE iLastCount  AS INTEGER NO-UNDO.
    DEFINE VARIABLE iFirstSize  AS INTEGER NO-UNDO.
    DEFINE VARIABLE iSecondSize AS INTEGER NO-UNDO.
    DEFINE VARIABLE mTemp       AS MEMPTR  NO-UNDO.


    ASSIGN mySecond = memptrTrim(mySecond).


    ASSIGN
     iFirstSize = GET-SIZE(myFirst) - 1
     iSecondSize = GET-SIZE(mySecond) - 1
    .


    SET-SIZE(mTemp) = 0.
    SET-SIZE(mTemp) = iSecondSize + 1 + iFirstSize.
    ASSIGN
     iCopyCount = 0
     iLastCount = 0
    .
    /* Copy the first memptr into our temp memptr */
    REPEAT:
        ASSIGN iCopyCount = MIN(iFirstSize - iLastCount,1028).
        PUT-BYTES(mTemp,1 + iLastCount) = GET-BYTES(myFirst,iLastCount + 1,iCopyCount).
        ASSIGN iLastCount = iLastCount + iCopyCount.
        IF iLastCount = iFirstSize THEN LEAVE.
    END.


    /* Re-initialize */
    ASSIGN
     iCopyCount = 0
     iLastCount = 0
    .
    /* Copy the second memptr into our temp memptr */
    REPEAT:
        ASSIGN iCopyCount = MIN(iSecondSize - iLastCount,1028).
        PUT-BYTES(mTemp,1 + iLastCount + iFirstSize) = GET-BYTES(mySecond,iLastCount + 1,iCopyCount).
        ASSIGN iLastCount = iLastCount + iCopyCount.
        IF iLastCount = iSecondSize THEN LEAVE.
    END.


    RETURN mTemp.



END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION MemptrTrim C-Win 
FUNCTION MemptrTrim RETURNS MEMPTR
  ( INPUT myMemPtr AS MEMPTR ) :
/*------------------------------------------------------------------------------
  Purpose:  Get rid of everything after the first null char in a memptr.
    Notes:  
------------------------------------------------------------------------------*/
    DEFINE VARIABLE myReturn  AS MEMPTR.
    DEFINE VARIABLE iBytes    AS INTEGER NO-UNDO.
    DEFINE VARIABLE iNullPos  AS INTEGER NO-UNDO.
    DEFINE VARIABLE iLength   AS INTEGER NO-UNDO.
    DEFINE VARIABLE iThisByte AS INTEGER NO-UNDO.


    ASSIGN iLength = GET-SIZE(myMemPtr).


    DO WHILE iBytes < iLength
     AND iNullPos = 0:
        ASSIGN iBytes = iBytes + 1.
        ASSIGN iThisByte = GET-BYTE(myMemPtr,iBytes).
        IF iThisByte = 0 THEN iNullPos = iBytes.
    END.
    IF iNullPos = 0 THEN iNullPos = iLength.


    SET-SIZE(myReturn) = 0.
    SET-SIZE(myReturn) = iNullPos.
    PUT-BYTES(myReturn,1) = GET-BYTES(myMemPtr,1,iNullPos - 1).


    RETURN myReturn.


END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION UrlParse C-Win 
FUNCTION UrlParse RETURNS LOGICAL(
 INPUT myURL AS CHAR,
 OUTPUT myHost AS CHAR,
 OUTPUT myPort AS CHAR,
 OUTPUT myPath AS CHAR  
) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  IF NOT myUrl BEGINS "http" THEN ASSIGN myUrl = myUrl + "http://".
  IF NUM-ENTRIES(myURL,"/") < 3 THEN RETURN FALSE.
  
  IF myUrl BEGINS "http://" THEN ASSIGN myPort = "80".
  ELSE IF myUrl BEGINS "https://" THEN RETURN FALSE.
  
  ASSIGN myHost = ENTRY(3,myUrl,"/").
  IF NUM-ENTRIES(myHost,":") = 2  
   THEN ASSIGN
   myPort = ENTRY(2,myhost,":")
   myHost = ENTRY(1,myHost,":")
  .
  ASSIGN myPath = SUBSTRING(myUrl,INDEX(myURL,"/",LENGTH(myhost) + 5)).
  RETURN TRUE.
  
  


END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

